#*---------------------------------------------------------------------------+
#
#     MODULE NAME:   PMPRINTF.MAK
#
#         $Author:   Dennis_Bareis  $
#                    Andreas Buchinger  2009-2024
#       $Revision:   1.2  $
#           $Date:   28 Sep 1996 15:08:22  $
#        $Logfile:   C:/PROJECTS/OS2/PVCS.IT/PMPRINTF/PMPRINTF.MAV  $
#
#     DESCRIPTION:
#
#---------------------------------------------------------------------------*/


MAKE_IN_PASS1_LIST           =                \

MAKE_IN_PASS2_LIST           =                \
                                PMPFLOG.EXE   \
                                PMPRINTF.EXE  \
                                WPSDEBUG.LIB  \
                                PMPRINTF.LIB  \
                                PMPRINTF.DLL  \
                                WPSDEBUG.DLL  \
                                TESTPF.EXE    \
                                WPSTEST.DLL   \
                                PMPRINTF.HLP  \
                                PMPRINTF.INF

.INCLUDE $(SUPPORT)\PRJVAC30.MAK
#############################################################################


# 20090816 AB make DEBUG build cause a trap in pmprintf.dll with dataseeker
DEBUG_WITH_IPMD = RemoveLeading#ToAllowDebuggingWithIPMD
#DEBUG_COMPILE = /Ti+  20231229 add /Tm+ debug memory support does produce non startable pmprintf.exe
DEBUG_COMPILE = /Ti /Se /Ss /G5 /Sp4 /Su4
#DEBUG_LINK    = /DEBUG /LINENUMBERS 20231229 remove /LINE...
DEBUG_LINK    = /DEBUG
#OPTIMISE      = /O+
#_LINK_FLAGS_EXE = $(DEBUG_LINK) /NOI /ALIGN:16 /BASE:65536 /STACK:0x80000   # 20231229 remove some options
_LINK_FLAGS_EXE = $(DEBUG_LINK) /NOEXEpack /NOI /MAP /LINENUMBERS /STACK:0x80000
#LINK_FLAGS_DLL = $(DEBUG_LINK) /NOI /ALIGN:16     # 20231229 remove some options
LINK_FLAGS_DLL = $(DEBUG_LINK) /NOEXEpack /MAP /NOI
C_FLAGS_OB     = $(DEBUG_COMPILE)
C_FLAGS_OBJ    = $(DEBUG_COMPILE)

_MAPSYM_ENABLED = YES

PMPRINTF.EXE:               \
              PfExe.OBJ     \
              FeCommon.OBJ  \
              PmPrintf.RES  \
              bldlevel.DEF
              %set LINK_FLAGS_EXE = $(_LINK_FLAGS_EXE) /PMTYPE:PM
              %do MAKE_EXE

PMPFLOG.EXE:                \
              PMPFLOG.OBJ   \
              FeCommon.OBJ  \
              bldlevel.DEF
              %set LINK_FLAGS_EXE = $(_LINK_FLAGS_EXE) /PMTYPE:VIO
              %do MAKE_EXE

PMPRINTF.DLL:               \
              PMPRINTF.OBJ  \
              RexxPmPf.OBJ  \
              REXX.LIB      \
              PMPRINTF.DEF  \
#              bldlevel.DEF
              %do MAKE_DLL

PMPRINTF.LIB:   PMPRINTF.DEF
#                bldlevel.DEF
              @echo Do --MAKE_DLL_IMPORT_LIBRARY--(PMPRINTF)
              %do MAKE_DLL_IMPORT_LIBRARY


WPSDEBUG.DLL:               \
              WPSDEBUG.OBJ  \
              WPSDEBUG.DEF  \
              PMPRINTF.LIB  \
              SOMtk.LIB
              %do MAKE_DLL


WPSDEBUG.LIB:   WPSDEBUG.DEF
              @echo Do --MAKE_DLL_IMPORT_LIBRARY--(WPSDEBUG)
              %do   MAKE_DLL_IMPORT_LIBRARY


TESTPF.EXE:                 \
              TESTPF.OBJ    \
              bldlevel.DEF  \
              PMPRINTF.LIB
              %set LINK_FLAGS_EXE = $(_LINK_FLAGS_EXE) /PMTYPE:VIO
              %do  MAKE_EXE

WpsTest.DLL:                \
              WpsTest.OBJ   \
              WPSDEBUG.LIB  \
              SOMtk.LIB       \
              bldlevel.DEF
              %do MAKE_DLL




#############################################################################
##########################[ PRODUCTION EXPORT RULES #########################
#############################################################################
EXPORT_LIST =   EXPORT_AFTER_MAKE           \
                $(OUTPUT_DIRECTORY)         \
                $(OUTPUT_DIRECTORY)\PACKAGE \
                WPSDEBUG.LIB                \
                PMPRINTF.LIB                \
                PMPRINTF.DLL                \
                WPSDEBUG.DLL                \
                PMPRINTF.EXE                \
                PMPFLOG.EXE                 \
                PMPRINTF.HLP                \
                PMPRINTF.INF
.INCLUDE $(SUPPORT)\PRJEXPRT.MAK
EXPORT_LIST =   EXPORT_AFTER_MAKE           \
                .                           \
                $(OUTPUT_DIRECTORY)\PACKAGE \
                WPSDEBUG.H                  \
                PMPRINTF.H                  \
                README.UPL                  \
                PMPRINTF.DIZ
.INCLUDE $(SUPPORT)\PRJEXPRT.MAK




#############################################################################
##########################[ TESTING EXPORT RULE ]############################
#############################################################################
EXPORT_LIST =   EXPORT_AFTER_MAKE         \
                $(OUTPUT_DIRECTORY)       \
                E:                        \
                WpsTest.DLL               \
                WpsDebug.DLL              \
                PMPRINTF.DLL
.INCLUDE $(SUPPORT)\PRJEXPRT.MAK




#############################################################################
##########################[ LOAD DEPENDANCY FILE ]###########################
#############################################################################
%if !%defined(SUE_NODEP)
.INCLUDE $(OUTPUT_DIRECTORY)\MAKE.DEP
%endif
