/* Test Procedure for the REXX -> PMPRINTF.EXE interface */


/*--- Define PMPRINTF REXX API Functions to rexx ----------------------------*/
call RxFuncAdd  'RexxPmpf',                         'PmPrintf', 'RexxPmpf';
call RxFuncAdd  'RexxPmPrintfModeSet',              'PmPrintf', 'RexxPmPrintfModeSet';
call RxFuncAdd  'RexxPmPrintfQueueNameThisProcess', 'PmPrintf', 'RexxPmPrintfQueueNameThisProcess';


/*--- Set SIGL Rc for demo purposes (Show unwanted OS/2 Bug/Feature) --------*/
call SetSiglToCallersLine;

/*--- Tell PMPRINTF to use default queue name (useless but good example) ----*/
call RexxPmPrintfQueueNameThisProcess "\QUEUES\PRINTF32";

/*--- Send a string to PMPRINTF.EXE (use default mode) ----------------------*/
PfRc = RexxPmpf('The time is now ' || time() || ' (default PMPRINTF Mode)');
say 'PMPRINTF #1 returned an Rc of ' || PfRc;


/*--- Send a string to PMPRINTF.EXE (Reset mode to 0) -----------------------*/
call RexxPmPrintfModeSet 0;
PfRc = RexxPmpf('The time is now ' || time() || ' (PMPRINTF Mode set to 0)');
say 'PMPRINTF #2 returned an Rc of ' || PfRc;


/*--- Send a string to PMPRINTF.EXE (Reset mode to 0x00000002) --------------*/
call RexxPmPrintfModeSet "0x00000002";
PfRc = Debug('The time is now ' || time() || ' (PMPRINTF Mode set to 0x00000002)');
say 'PMPRINTF #3 returned an Rc of ' || PfRc;


/*--- If uncommented the following will cause a syntax error (too many parms) ---*/
/* PfRc = RexxPmpf('This will die', '2nd parameter');                              */
/* say 'PMPRINTF  returned an Rc of ' || PfRc || ' (REXX PROC SHOULD HAVE DIED'; */



/*--- I want to be able to overwrite my DLL during makes! -------------------*/
call RxFuncDrop  'RexxPmpf';
say '';
say 'Thats All Folks!';




/*===========================================================================*/
SetSiglToCallersLine:
/*===========================================================================*/
   return;


/*===========================================================================*/
Debug:
/*                                                                           */
/* Due to a rexx bug or feature you must call this function to ensure that   */
/* the line number shown in the header of the message will be correct.       */
/*===========================================================================*/
   return( RexxPmpf(arg(1)) );

