/*---------------------------------------------------------------------------+
|
|     (C)opyright Dennis Bareis and Andreas Buchinger
|     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
|
|     MODULE NAME:   TESTPF.C
|
|
|         $Author:   Dennis_Bareis  $
|                    Andreas Buchinger  2009-2024
|       $Revision:   1.0  $
|           $Date:   17 Aug 1996 13:39:16  $
|        $Logfile:   C:/PROJECTS/OS2/PVCS.IT/PMPRINTF/TESTPF.C_V  $
|
|     DESCRIPTION:   This is a test program for programmer's interface to
|                    PMPRINT.
+---------------------------------------------------------------------------*/

/*------ Make constant string definition more efficient & protect them! -----*/
#pragma  strings(readonly)

/*------ Include required Header files --------------------------------------*/
#define  INCL_DOSPROCESS
#define  INCL_NOPMAPI
#define  INCL_LONGLONG  // 20090705 AB

#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define  __PMPRINTF__
#include "PMPRINTF.H"

#include <float.h>



/*===========================================================================*/
int main(int argc, char *argv[])
/*===========================================================================*/						
	{
	int   Index = 2;
	ULONG Mode;
	float fTest = 12.3456778;
	ULONG Version;

	/*--- Display the default Queue Name -------------------------------------*/
	printf("The default Queue Name is \"%s\"\n", PmPrintfQueueNameThisProcess(NULL));
	printf("float test %f\n", fTest / 0.8567 + Index);

	/*--- Determine the queue name -------------------------------------------*/
	DosBeep(3000, 80);
	if ( argv[1] != NULL )
		{
		/*--- We are changing the queue name from the default ----------------*/
		printf("Changing Queue name to \"%s\"\n", argv[1]);
		PmPrintfQueueNameThisProcess(argv[1]);
		}

	/*--- Display the current version # of the interface ---------------------*/
	PmPrintfDisplayInterfaceVersionInfo();

	/*--- find out what the current mode is ----------------------------------*/
	Mode = PmPrintfModeSet(0);
	PmPrintfModeSet(Mode);										 //Restore original mode
	PmpfF(("Starting (Mode=%08X)", Mode));

	/*--- Output a couple of simple strings ----------------------------------*/
	PmPrintf("Hello this is line 1");
	PmPrintf("Hello this is line 2");

	/*--- Say here I am ------------------------------------------------------*/
	DebugHereIAm();

	/*--- Do a very long line plus a multi line output (with bells) ----------*/
	PmPrintf("Hello this is line 3 xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx3 end");
	PmPrintf("Hello \7\7\athis is line 4\nHello this is li\7ne 5");

	PmpfF(("Test float %f", fTest / 0.856));

	/*--- Output a lot of lines (to time my interface to make sure its speedy!) ---*/
	for ( Index=1; Index <= 400; Index++ )
		PmPrintf("Loop #%d", Index);


	/*--- Define a new "here I am" message and use it ------------------------*/
#undef   PMPRINTF_HERE_I_AM_MSG
#define  PMPRINTF_HERE_I_AM_MSG  " <This is a new \"HereIAm\" message>"
	DebugHereIAm();
	_DebugHereIAm();

	Version = PmPrintfGetVersion(0);
	PmPrintf("Version of PmPrintf package is %d", Version);
	

	/*--- Thats all Folks ----------------------------------------------------*/
	_PmpfF(("Ending"));
	DosBeep(3500, 80);
  return(__LINE__);
	}



