.*---------------------------------------------------------------------------
.*
.*     MODULE NAME:   PMPRINTF.IPF
.*
.*         $Author:   Dennis_Bareis and Andreas Buchinger $
.*       $Revision:   1.1  $
.*           $Date:   28 Sep 1996 15:08:36  $
.*                      20170829 AB
.*        $Logfile:   C:/PROJECTS/OS2/PVCS.IT/PMPRINTF/PMPRINTF.IPV  $
.*
.*     DESCRIPTION:
.*
.*---------------------------------------------------------------------------



.im  IPFGEN.IPF
.imd PFEXE.H
:userdoc.
:Title.PMPRINTF By Dennis Bareis (<$IpfTimeVersion?>)
:docprof toc=123456.



.*===========================================================================
:Heading p1='Introduction res=&IDHLP_PMPRINTF_EXE.' p2='Introduction'.
.*===========================================================================
:i1 id=Introduction.Introduction

:BigTitle p1='WHAT IS PMPRINTF'.

:p.This version of PMPRINTF allows you to direct the output from
debugging statements placed in code (using printf() like
statements) to a highly configurable
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'. or into a
:LinkToText p1='PMPFLOG_EXE' p2='log file'.
of your choice.

:p.The interfaces described here were developed by
:LinkToText p1='DennisBareis' p2='Dennis Bareis'., the following
components being supplied&colon.


:OrdList.
:li.:Magenta p1='PMPRINTF&per.EXE'.
.br
This is the PM
viewer (:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'.).  It provides
logging functions as well as search functions.  The viewer can accept
output from any number of processes at once.
.br
.br
This component is based on code originally written by
Mike Cowlishaw.  All other components were written from scratch, the
only similarity with Mike's code is that the same queue interface
is used, this was done so that people have the option of using
either end independantly or both together.

:li.:Magenta p1='PMPFLOG&per.EXE'.
.br
This is a text based

:LinkToText p1='PMPFLOG_EXE' p2='logging program'..  Since it does
not require PM it could be used to debug programs where the use of
:LinkToText p1='PMPRINTF_EXE' p2='PMPRINTF&per.EXE'. is not
possible.  This program can accept
output from any number of processes at once.

:li.:Magenta p1='The "C" Interface'.
.br
This supplies the header file
":LinkToText p1='PMPRINTF_H' p2='PMPRINTF&per.H'.", and library file
"PMPRINTF.LIB" which allow you to send debug output via the queue
mechanism to the PM viewer.  The DLL "PMPRINTF.DLL" needs to be
loaded as this supplies the code that does the work on your behalf.

:li.:Magenta p1='The "REXX" Interface'.
.br
You can link to
:LinkToText p1='FunctionsRexxPMPRINTF' p2='functions'.
within "PMPRINTF.DLL", which will allow
your rexx procedures (and hence standard batch files) to also send
debug output to the PM viewer.

:li.:Magenta p1='The "SOM/WPS" Interface'.
.br
.dm WpsDebugInterface on
This :LinkToText p1='FunctionsWPSDEBUG' p2='interface'.
allows a SOM class to easily output debugging
information.  It is better to use this interface as it will ensure
that messages which are generated by existing classes will be
correctly placed into the output.  This may help in debugging your
particular problem.
.dm off
:WpsDebugInterface.
:eOrdList.

:p.The original PM viewer was developed by
:Bold p1='Mike Cowlishaw'., IBM UK Laboratories.  The viewer supplied
here is an upgrade based on Mike's viewer version 2.56 and receives
its data over the queue in exactly the same format.




.*===========================================================================
:Heading p1='PMPRINTF_EXE' p2='PMPRINTF&per.EXE (Back End)'.
.*===========================================================================
:i1 id=PMPRINTF_EXE.PMPRINTF&per.EXE

:p.This is the PM viewer, your applications will send their debug
messages to this viewer via a named queue.  This queue does not have a
limit and so messages should not get lost.

:p.It has many :LinkToText p1='MenuOptions' p2='Options'. which
will allow you to tune it to your requirements.  Some
:LinkToText p1='PmPrintfCmdLine' p2='command line'. options
are also available.

:p.This viewer is a 32 bit version and so will run on OS/2 version
2.0 onwards.  Some non-critical functions may not function unless you
are on Warp or greater.  This code has only been tested on Warp,
sorry...

:p.If you can suggest any enhancements or find bugs please contact
:LinkToText p1='DennisBareis' p2='Dennis Bareis'..




.*===========================================================================
:HeadingLevelDown.
:Heading p1='PmPrintfCmdLine' p2='Command Line Options'.
:HeadingLevelDown.
.*===========================================================================
:i2 refid=PMPRINTF_EXE.Command Line Switches

:BigTitle p1='Command Line Switches - PMPRINTF&per.EXE'.

:p.The following switches are available for altering the way this
program operates&colon.


:UnNumberedListCompact.
:li.:LinkTo p1='NewQueueName'.
:eUnNumberedListCompact.


.*===========================================================================
:Heading p1='NewQueueName' p2='NewQueueName'.
.*===========================================================================


:BigTitle p1='PMPRINTF.EXE Switch - NewQueueName'.

:p.This option allows you to change the name of the named queue, when
specifying a replacement do not start with the
":DarkGreen p1='\QUEUES\'."  part as this is assumed.

:p.You will need to change from the default if the program being
debugged has changed from the default queue, for example a rexx
program might use the
:LinkToFunction p1='RexxPmPrintfQueueNameThisProcess'. to change the
default queue.


:BigTitle p1='EXAMPLE'.

:Example.
PMPRINTF.EXE /NewQueueName:MYQUEUE
:eExample.



.*===========================================================================
:HeadingLevelUp.
:Heading p1='PmprintfkeysHelp res=&IDHLP_PMPRINTF_EXE_KEYS.' p2='Key &amp. Mouse Actions'.
.*===========================================================================
:i1 id=PmprintfKeys.Key &amp. Mouse Actions



:BigTitle p1='MOUSE'.

:p.If you :Bold p1='right click'. on the listbox a context menu will
appear.  The mouse can also be used to mark multiple line in the
listbox using normal PM conventions.


:BigTitle p1='KEYS'.


:UnNumberedList.
:li.:Bold p1='Home'.
.br
This key takes you to the start of the captured messages (1st line).

:li.:Bold p1='End'.
.br
This key takes you to the end of the captured messages (last line).

:li.:Bold p1='PageUp'.
.br
This key takes you backwards one page.

:li.:Bold p1='PageDown'.
.br
This key takes you forwards one page.

:li.:Bold p1='UpArrow'.
.br
This key takes you backwards one line.

:li.:Bold p1='DownArrow'.
.br
This key takes you forwards one line.

:li.:Bold p1='RightArrow'.
.br
This key takes you to the right a few columns (if there is data off
the screen).

:li.:Bold p1='LeftArrow'.
.br
This key takes you to the left a few columns.

:li.:Bold p1='Enter'.
.br
Add a
:LinkToText p1='ActionAddComment' p2='comment'..

:li.:Bold p1='Space'.
.br
Highlight &amp. unhighlight a line.

:li.:Bold p1='Others'.
.br
Other keys are documented in the menu structure of the application.

:eUnNumberedList.



.*===========================================================================
:Heading p1='ApplicationMenu' p2='Application Menu'.
.*===========================================================================

:p.The application menu is described in this section.

:p.Note that you can also get up a contex menu by right clicking on
the listbox, this menu is largely the same as the application menu.

.*===========================================================================
:HeadingDown p1='MenuActions res=&IDM_ACTIONS.' p2='Actions Menu'.
.*===========================================================================
:i1 id=MenuActions.Menu - Actions

:p.This menu holds the main commands that you can perform, unlike the
":LinkToText p1='MenuOptions' p2='Options'." menu where you can
configure how this program will operate.


.*===========================================================================
:HeadingDown p1='MenuDisplayedMessages res=&IDM_CAPTURED_LINES.' p2='Displayed Messages Menu'.
.*===========================================================================

:p.This menu allows you to set the following values&colon.


:UnNumberedListCompact.
:li.:LinkToText p1='ActionWriteToLog' p2='Write To Log'.
:li.:LinkToText p1='ActionAddComment' p2='Add Comment'.
:li.:LinkToText p1='ActionErase' p2='Erase Listbox'.
:eUnNumberedListCompact.



.*===========================================================================
:HeadingDown p1='ActionWriteToLog res=&IDMI_WRITE_LISTBOX_TO_LOGFILE.' p2='Write To Log'.
.*===========================================================================
:i2 refid=MenuActions.Write To Log

:p.This action dumps the whole listbox to the
:LinkToText p1='OptionChangeLogFile' p2='currently selected log file'..


.*===========================================================================
:Heading p1='ActionAddComment res=&IDMI_ADD_COMMENT.' p2='Add Comment'.
.*===========================================================================
:i2 refid=MenuActions.Add Comment

:p.When you select this option you will be asked for a comment, if no
lines are highlighted, the comment is placed at the end of the
messages, if a line is highlighted then its placed after this line.

:p.Note that if logging is on then the line is added to the :Bold p1='end'.
of the :LinkToText p1='OptionChangeLogFile' p2='logfile'..


.*===========================================================================
:Heading p1='ActionErase res=&IDMI_EMPTY_LISTBOX.' p2='Erase Listbox'.
.*===========================================================================
:i2 refid=MenuActions.Erase Listbox

:p.This option clears the listbox of all lines.


.*===========================================================================
:HeadingUp p1='ActionMenuFind res=&IDM_FIND.' p2='Find Menu'.
.*===========================================================================

:p.This menu holds all find actions as follows&colon.


:UnNumberedListCompact.
:li.:LinkToText p1='ActionFind' p2='Find'.
:li.:LinkToText p1='ActionFindNext' p2='Find Next'.
:li.:LinkToText p1='ActionFindPrevious' p2='Find Previous'.
:eUnNumberedListCompact.

.dm MentionSearchOptions on
:p.Note that you can control whether or not the search is
:LinkToText p1='OptionCaseSensitiveSearches' p2='case sensitive'..
.dm off
:MentionSearchOptions.


.*===========================================================================
:HeadingDown p1='ActionFind res=&IDMI_FIND.' p2='Find'.
.*===========================================================================
:i2 refid=MenuActions.Find

:p.You will be prompted for a string, enter this value and the
:Bold p1='forwards'. search will begin.

:MentionSearchOptions.



.*===========================================================================
:Heading p1='ActionFindNext res=&IDMI_FINDNEXT.' p2='Find Next'.
.*===========================================================================
:i2 refid=MenuActions.Find Next

:p.This will search forwards from the last matching location for the
string you
:LinkToText p1='ActionFind' p2='specified'. (wrapping will occur).

:MentionSearchOptions.


.*===========================================================================
:Heading p1='ActionFindPrevious res=&IDMI_FINDPREV.' p2='Find Previous'.
.*===========================================================================
:i2 refid=MenuActions.Find Previous

:p.This will search backwards from the last matching location for the
string you
:LinkToText p1='ActionFind' p2='specified'. (wrapping will occur).

:MentionSearchOptions.



.*===========================================================================
:HeadingUp p1='ActionEraseLog res=&IDMI_DELETE_LOGFILE.' p2='Erase Log'.
.*===========================================================================
:i2 refid=MenuActions.Erase Log

:p.This option will erase the
:LinkToText p1='OptionChangeLogFile' p2='current log file'..


.*===========================================================================
:Heading p1='ActionClose res=&IDMI_EXIT_PGM.' p2='Close'.
.*===========================================================================
:i2 refid=MenuActions.Close

:p.This option terminates the program, most settings are remembered
for when the program restarts.



.*===========================================================================
:HeadingUp p1='MenuOptions res=&IDM_OPTIONS.' p2='Options'.
.*===========================================================================
:i1 id=MenuOptions.Menu - Options

:p.This menu holds the configurable options unlike the
":LinkToText p1='MenuActions' p2='Actions'." menu whose items when
selected do something!

.dm OptionCheckedWhenSelected on
:p.This option will be displayed checked in the menu when selected.
.dm off


.*===========================================================================
:HeadingDown p1='OptionCaseSensitiveSearches res=&IDHLP_IDMI_CASE_SENSITIVE_SEARCHES.' p2='Case Sensitive Searches'.
.*===========================================================================
:i2 refid=MenuOptions.Case Sensitive Searches

:p.This option when selected will cause the
:LinkToText p1='ActionFind' p2='Find'.,
:LinkToText p1='ActionFindNext' p2='Find Next'. &amp.
:LinkToText p1='ActionFindPrevious' p2='Find Previous'. search operations
to be case sensitive.

:OptionCheckedWhenSelected.


.*===========================================================================
:Heading p1='OptionsMenuLog res=&IDHLP_IDM_LOG_OPTIONS.' p2='Log Options Menu'.
.*===========================================================================


.*===========================================================================
:HeadingDown p1='OptionLogMessages res=&IDHLP_IDMI_LOG_NEW_LISTBOX_LINES.' p2='Log Messages'.
.*===========================================================================
:i2 refid=MenuOptions.Log Messages

:p.This option when selected wil cause lines to be automatically
added to the end of the current log file as they are being added to
the list box.

:p.The name of the log file can be set with the
:LinkToText p1='OptionChangeLogFile' p2='Change Log File'. option.

:OptionCheckedWhenSelected.


.*===========================================================================
:Heading p1='OptionLogTimeStampMessages res=&IDHLP_IDMI_ADD_TIMESTAMP_TO_LOGGED_LINES.' p2='Timestamp Messages'.
.*===========================================================================
:i2 refid=MenuOptions.Timestamp Messages - to log

:p.When outputting messages to the log, do we wish to add a
timestamp?

:p.Note that you can control how the time is formatted with the
:LinkToText p1='OptionTimesFormat' p2='Time&apos.s Format'. option.

:OptionCheckedWhenSelected.


.*===========================================================================
:Heading p1='OptionChangeLogFile res=&IDHLP_IDMI_CHANGE_LOGFILE_NAME.' p2='Change Log File'.
.*===========================================================================
:i2 refid=MenuOptions.Change Name of Log File

:p.This option is used to specify that a new logfile should be used,
if logging is on the previous logfile is first closed and then the
new file is opened.



.*===========================================================================
:HeadingLevelUp.
:Heading p1='OptionsMenuListBox res=&IDHLP_IDM_LISTBOX_OPTIONS.' p2='List Box Options Menu'.
.*===========================================================================


.*===========================================================================
:HeadingDown p1='OptionRestrictListboxLines res=&IDHLP_IDMI_MAX_LINES_IN_LISTBOX.' p2='Restrict Listbox Lines'.
.*===========================================================================
:i2 refid=MenuOptions.Restrict Listbox Lines

:p.This option controls the maximum number of lines the listbox
holds.  You may wish to keep the listbox short or maybe you do not
want to lose messages in which case you might specify a number like
32000.


.*===========================================================================
:Heading p1='OptionBeepOnArrival res=&IDHLP_IDMI_BEEP_ON_MSG_ARRIVAL.' p2='Beep On Arrival'.
.*===========================================================================
:i2 refid=MenuOptions.Beep On Arrival

:p.This option if selected will cause any messages read from the
named queue to generate a beep.  This can be useful if messages are
infrequent but you wish to know immediately one arrives.

:OptionCheckedWhenSelected.

:p.This option is not restored when the program restarts.



.*===========================================================================
:HeadingLevelUp.
:Heading p1='OptionsMenuTime res=&IDHLP_IDM_TIME_OPTIONS.' p2='Time Options Menu'.
.*===========================================================================

:p.This menu contains the time related options.


.*===========================================================================
:HeadingDown p1='OptionDisplayTime res=&IDHLP_IDMI_ADD_TIME_TO_LISTBOX_ENTRIES.' p2='Display Time'.
.*===========================================================================
:i2 refid=MenuOptions.Display Time

:p.This option determines whether or not the time should be displayed
in the list box.  You would normally wish this to be on.

:OptionCheckedWhenSelected.

:p.Note that you can control how the time is formatted with the
:LinkToText p1='OptionTimesFormat' p2='Time&apos.s Format'. option.



.*===========================================================================
:Heading p1='OptionTimesFormat res=&IDHLP_IDMI_SPECIFY_TIME_FMT.' p2='Time&apos.s Format'.
.*===========================================================================
:i2 refid=MenuOptions.Time's Format

:p.This option allows you to set the format of the time, you are
asked for a string which can contain ':Bold p1='%'.' symbols which
will determine what goes where.

:p.The default format is "%a %I&colon.%M&colon.%S%p> ", this results in listbox
items similar to&colon.

.dm TimeFmtExampleAndCodes on

:ExampleFormatted.
   :DarkGreen p1='Sun 04&colon.05&colon.08pm> '.P012,T1 &colon. ANZDSKT.C, 449, anzdskt__wpModifyPopupMenu() &colon.  Here I am
:eExampleFormatted.

:p.A complete table of ':Bold p1='%'.' symbols follows&colon.

:Example.
 Ŀ
  SPECIFIER MEANING                                                           
 Ĵ
  "%a"      Insert abbreviated weekday name of locale.                        
 Ĵ
  "%A"      Insert full weekday name of locale.                               
 Ĵ
  "%b"      Insert abbreviated month name of locale.                          
 Ĵ
  "%B"      Insert full month name of locale.                                 
 Ĵ
  "%c"      Insert date and time of locale.                                   
 Ĵ
  "%d"      Insert day of the month (01-31).                                  
 Ĵ
  "%H"      Insert hour (24-hour clock) as a decimal number (00-23).          
 Ĵ
  "%I"      Insert hour (12-hour clock) as a decimal number (01-12).          
 Ĵ
  "%j"      Insert day of the year (001-366).                                 
 Ĵ
  "%m"      Insert month (01-12).                                             
 Ĵ
  "%M"      Insert minute (00-59).                                            
 Ĵ
  "%p"      Insert equivalent of either AM or PM of locale.                   
 Ĵ
  "%S"      Insert second (00-61).                                            
 Ĵ
  "%U"      Insert week number of the year (00-53) where Sunday is the first  
            day of the week.                                                  
 Ĵ
  "%w"      Insert weekday (0-6) where Sunday is 0.                           
 Ĵ
  "%W"      Insert week number of the year (00-53) where Monday is the first  
            day of the week.                                                  
 Ĵ
  "%x"      Insert date representation of locale.                             
 Ĵ
  "%X"      Insert time representation of locale.                             
 Ĵ
  "%y"      Insert year without the century (00-99).                          
 Ĵ
  "%Y"      Insert year.                                                      
 Ĵ
  "%Z"      Insert name of time zone, or no characters if time zone is not    
            available.                                                        
 Ĵ
  "%%"      Insert %.                                                         
 
:eExample.
.dm off
:TimeFmtExampleAndCodes.





.*===========================================================================
:HeadingLevelUp.
:Heading p1='OptionsMenuPresParms res=&IDHLP_IDM_PRESPARMS_OPTIONS.' p2='Presentation Parameters Options Menu'.
.*===========================================================================

:p.The presentation parameters include the following&colon.


:UnNumberedListCompact.
:li.Position of the windows.
:li.Fonts used in lisbox, menu etc.
:li.Colors used.
:eUnNumberedListCompact.

:p.Note that currently listbox colors are not save/restored, I'm not
sure why, when I get time I will try to look at this.



.*===========================================================================
:HeadingDown p1='OptionPresParmSave res=&IDHLP_IDMI_SAVE_PRESPARMS.' p2='Save'.
.*===========================================================================
:i2 refid=MenuOptions.Presentation Parameter - Save

:p.This option when selected will save the current presentation
parameters whenever a window is closed.

:p.Once you have saved them you may not wish to continue to do so
every time or you may wish to experiment with differnt fonts etc without
the danger of losing the masterpiece you currently have.

:OptionCheckedWhenSelected.



.*===========================================================================
:Heading p1='OptionPresParmRestore res=&IDHLP_IDMI_RESTORE_PRESPARMS.' p2='Restore'.
.*===========================================================================
:i2 refid=MenuOptions.Presentation Parameter - Restore

:p.This option when selected will restore the presentation
parameters whenever a window is opened.

:p.You might deselect this option if you have decided you wish to
restore the default presentation parameters.

:OptionCheckedWhenSelected.





.*===========================================================================
:HeadingLevelUp.
:HeadingLevelUp.
:Heading p1='MenuHalt res=&IDHLP_IDMI_PAUSE_RESUME.' p2='Halt/Restart'.
.*===========================================================================
:i1 id=MenuHalt.Menu - Halt/Restart

:p.This option will toggle the pause mode.  If
":Bold p1='halted'." no more messages will be retrieved from the names
queue.  The messages will not become lost but will be picked up again
when you ":Bold p1='restart'." queue processing.

:p.Any messages that have been posted by the named queue reader
thread will still be processed when you pause processing.

:p.It would make sense to hold the queue if you wish to add
:LinkToText p1='ActionAddComment' p2='comments'. to the listbox contents.



.*===========================================================================
:HeadingLevelUp.
:HeadingLevelUp.
:Heading p1='PMPFLOG_EXE' p2='PMPFLOG&per.EXE (Back End)'.
.*===========================================================================
:i1 id=PMPFLOG_EXE.PMPFLOG&per.EXE

:p.This is a text based logger, your applications will send their debug
messages to this program via a named queue.  This queue does not have a
limit and so messages should not get lost.

:p.This program does not require PM running so it could be started in
config.sys, this would probably be the main reason for using this
program.

:p.If your production code contains some debugging statements you may
also wish to have these logged rather than lose them.

:p.This program takes all options from the
:LinkToText p1='PmPfLogCmdLine' p2='command line'. as the INI file can
only be read when PM is available.

:p.If you can suggest any enhancements or find bugs please contact
:LinkToText p1='DennisBareis' p2='Dennis Bareis'..


.*===========================================================================
:HeadingLevelDown.
:Heading p1='PmPfLogCmdLine' p2='Command Line Options'.
:HeadingLevelDown.
.*===========================================================================
:i2 refid=PMPFLOG_EXE.Command Line Switches

:BigTitle p1='Command Line Switches - PMPFLOG&per.EXE'.

:p.The following switches are available for altering the way this
program operates&colon.


:UnNumberedListCompact.
:li.:LinkToText p1='LogNewQueueName' p2='NewQueueName'.
:li.:LinkTo p1='LogFileName'.
:li.:LinkTo p1='LogTimeFmt'.
:eUnNumberedListCompact.


.*===========================================================================
:Heading p1='LogNewQueueName' p2='NewQueueName'.
.*===========================================================================


:BigTitle p1='PMPFLOG.EXE Switch - NewQueueName'.

:p.This option allows you to change the name of the named queue, when
specifying a replacement do not start with the
":DarkGreen p1='\QUEUES\'."  part as this is assumed.

:p.You will need to change from the default if the program being
debugged has changed from the default queue, for example a rexx
program might use the
:LinkToFunction p1='RexxPmPrintfQueueNameThisProcess'. to change the
default queue.

:BigTitle p1='EXAMPLE'.
:Example.
PMPFLOG.EXE /NewQueueName:MYQUEUE
:eExample.


.*===========================================================================
:Heading p1='LogFileName' p2='LogFileName'.
.*===========================================================================


:BigTitle p1='PMPFLOG.EXE Switch - LogFileName'.

:p.This option allows you to change the name of the log file which is
appended to as the program runs.

:BigTitle p1='EXAMPLE'.
:Example.
PMPFLOG.EXE /LogFileName:D:\TMP\MY.LOG
:eExample.



.*===========================================================================
:Heading p1='LogTimeFmt' p2='LogTimeFmt'.
.*===========================================================================


:BigTitle p1='PMPFLOG.EXE Switch - LogTimeFmt'.

:p.This option allows you to change the format of the time which is
inserted in front of each received message before its logged.  The
format string will contain ':Bold p1='%'.' symbols which
will determine what goes where.

:p.The default format is "%a %I&colon.%M&colon.%S%p> ", this results in
messages similar to&colon.

:TimeFmtExampleAndCodes.


:BigTitle p1='EXAMPLE'.
:Example.
PMPFLOG.EXE "/LogTimeFmt:%a %I:%M:%S%p> "
:eExample.


.*===========================================================================
:HeadingLevelUp.
:HeadingLevelUp.
:Heading p1='PMPRINTFInterface' p2='PMPRINTF Programmer Interface'.
.*===========================================================================

:p.The following programmer interfaces are supplied&colon.


:OrdList.
:li.:LinkToText p1='PMPRINTFCInterface' p2='PMPRINTF &apos.C&apos. Interface'.

:li.:LinkToText p1='PMPRINTFRexxInterface' p2='PMPRINTF Rexx Interface'.
:eOrdList.


.dm CPmprintfTestCode on
:p.You may wish to see the
:LinkToText p1='CExample' p2='complete &apos.C&apos. program'.
which I use to test the
interface as it uses many different functions &amp. macros.
.dm off
:CPmprintfTestCode.






.*===========================================================================
:HeadingLevelDown.
:Heading p1='PMPRINTFCInterface' p2='PMPRINTF &apos.C&apos. Interface'.
.*===========================================================================
:i1 id=PmPrintfInterfaceC.PMPRINTF 'C' Interface

:p.To use this interface you must include
":LinkToText p1='PMPRINTF_H' p2='PMPRINTF&per.H'." in your "C" code
and link to "PMPRINTF.LIB" during the link step.  At runtime the
"PMPRINTF.DLL" must be available.

:p.This interface supplies three main categories are follows&colon.


:OrdList.
:li.:Magenta p1='Interface Options'.
.br
These options allow you to specify how the interface should handle
your requests, the following functions are available&colon.

.dm PmprintfCategory1 on
:li.:LinkToFunction p1='PmPrintfModeSet'.
:li.:LinkToFunction p1='PmPrintfQueueNameThisProcess'.
.dm off

:UnNumberedListCompact.
:PmprintfCategory1.
:eUnNumberedListCompact.


:li.:Magenta p1='Functions &amp. Macros to generate debug output'.
.br
These functions &amp. macros unconditionally generate code, they are
used either for temporary output (you will remove the statements when
you have finished) or you plan to leave the statements in so that
debugging can be turned on in production code if required.  Available
operations in this category are&colon.

.dm PmprintfCategory2 on
:li.:LinkToFunction p1='PmPrintf'.
:li.:LinkToFunction p1='PmPrintfVa'.
:li.:LinkToFunction p1='PmPrintfString'.
:li.:LinkToFunction p1='PmPrintfDisplayInterfaceVersionInfo'.
:li.:LinkToFunction p1='Pmpf'.
:li.:LinkToFunction p1='PmpfF'.
:li.:LinkToFunction p1='DebugHereIAm'.
.dm off

:UnNumberedListCompact.
:PmprintfCategory2.
:eUnNumberedListCompact.

:li.:Magenta p1='Functions &amp. Macros to conditionly generate debug output'.
.br
This category includes macros which will either produce debug code or
will not produce code.  These means that debug code can be eliminated
from a production make without needing to remove the debug
statements.
.br
.br
The debug macros will only produce code if you have #defined
":Bold p1='_PMPRINTF_'." prior to including
":LinkToText p1='PMPRINTF_H' p2='PMPRINTF&per.H'." in your "C" code,
the following macros are available&colon.

.dm PmprintfCategory3 on
:li.:LinkToFunction p1='_Pmpf'.
:li.:LinkToFunction p1='_PmpfF'.
:li.:LinkToFunction p1='_DebugHereIAm'.
.dm off
:UnNumberedListCompact.
:PmprintfCategory3.
:eUnNumberedListCompact.

:eOrdList.

:CPmprintfTestCode.



.*===========================================================================
:HeadingLevelDown.
:Heading p1='FunctionsPMPRINTF' p2='Functions &amp. Macros'.
.*===========================================================================

:p.The following functions &amp. macros are available&colon.


:UnNumberedListCompact.
:PmprintfCategory1.
:PmprintfCategory2.
:PmprintfCategory3.
:eUnNumberedListCompact.

:CPmprintfTestCode.


.dm Rc0IfOk on
:p.A return code of 0 is returned if everything went OK.
.dm off
.dm NoNewLineRequired on
:p.Note that like all PMPRINTF operations a terminating new line is
not required and will if supplied generate a blank line.  If you wish
you may however send multiple lines - each terminated with a newline
('\n').
.dm off

:HeadingLevelDown.




.*===========================================================================
:Heading p1='PmPrintfDisplayInterfaceVersionInfo' p2='PmPrintfDisplayInterfaceVersionInfo'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.PmPrintfDisplayInterfaceVersionInfo

:BigTitle p1='DESCRIPTION - PmPrintfDisplayInterfaceVersionInfo'.

:p.This function takes no parameters and will output information
which indentifies the level of the interface you are using and sends
this to the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'..

:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.


:Example.
    ULONG _System PmPrintfDisplayInterfaceVersionInfo(void);
:eExample.

:Rc0IfOk.



.*===========================================================================
:Heading p1='PmPrintfModeSet' p2='PmPrintfModeSet'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.PmPrintfModeSet

:BigTitle p1='DESCRIPTION - PmPrintfModeSet'.

:p.This function is used to tell the interface how other functions
should operate, for example do you wish to hear a beep if the debug
output could not be sent to the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'.?

:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.


:Example.
    PMPRINTF_MODE _System PmPrintfModeSet(PMPRINTF_MODE NewMode);
:eExample.

:p.As you can see you supply the new mode and the API will return the
original mode (in case you would like to query it or restore it later
on).

:p.The mode is made up of one or more bits which should be or'ed
together if required.  The bits are described below&colon.

:UnNumberedList.
:li.:Magenta p1='PMPRINTF_SEND_TIME'.
.br
This bit will cause the time to be sent as a header field for every
line sent to the viewer, as the viewer can display
the time, this would not normally be required unless you wish to use
Mike's original viewer.
.br
.br
The format of the time sent by this interface is fixed while you can
configure the viewer to display it in any format.

:li.:Magenta p1='PMPRINTF_SEND_PROC_INFO'.
.br
This bit will cause the process ID &amp. thread ID to be sent as a
header field with all messages sent to the viewer.

:li.:Magenta p1='PMPRINTF_NOISE_ON_1ST_ERROR'.
.br
You can ensure that you are warned when an error occurs
so you realise debugging information has been lost.  This is not the
default as its possible that you may wish to include debugging
statements in production code and
:Italic p1='turn on debugging'. by simply starting
:LinkToText p1='PMPRINTF_EXE' p2='PMPRINTF&per.EXE'. or
:LinkToText p1='PMPFLOG_EXE' p2='PMPFLOG&per.EXE'., in this case you
don't want the interface beeping!

:li.:Magenta p1='PMPRINTF_NOISE_ON_OK_AGAIN'.
.br
If you would like the noise described above to occur on reconnection
with the viewer then this bit should be set.

:eUnNumberedList.




.*===========================================================================
:Heading p1='PmPrintfQueueNameThisProcess' p2='PmPrintfQueueNameThisProcess'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.PmPrintfQueueNameThisProcess

:BigTitle p1='DESCRIPTION - PmPrintfQueueNameThisProcess'.

:p.This function allows you to specify the name of the queue that
your information should be sent over.  To see the output you would
need to start the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'. so that it also uses
that queue.

:p.This would allow you to have multiple viewers open if debugging
complex problems or more likely have production code
:Bold p1='debug enabled'. where production code includes the debug
statements and each application uses its own queue.  If
you wish to begin debugging then you start a viewer with the correct
queue name for the application being debugged.

:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.


:Example.
    char * _System PmPrintfQueueNameThisProcess(char * StaticPmprintfQueueName);
:eExample.

:p.This function should be passed the name of the queue to be used,
it must be in ":Bold p1='static'." memory, by that I mean that it
must not change thoughout the life of the program, you can
malloc() this memory or use a static string for this purpose.

:p.All queue names must begin with "\QUEUES\" to be valid, a couple of
valid ones are&colon.

:UnNumberedListCompact.
:li.\QUEUES\APP1
:li.\QUEUES\SUE\FRED.EXE
:eUnNumberedListCompact.

:p.On return from this function the previous queue name is returned
or :Bold p1='NULL'. in case of error.

:p.Note that it is possible to use this function only to query the
current queue name by passing "NULL" instead of the name of a new
queue.



.*===========================================================================
:Heading p1='DebugHereIAm' p2='DebugHereIAm'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.DebugHereIAm

:BigTitle p1='DESCRIPTION - DebugHereIAm'.

:p.This macro takes no parameters and uses the
:LinkToFunction p1='PmpfF'. macro to display a fixed message.  This
of course means that very detailed information about where you are
will be generated by this very simple macro invokation.

:p.This macro is useful in cases where you are not sure if you are
reaching code you expect to and you don't want or need the hassle of
coding "I'm now at line 10 etc"...

:p.The value of the text which is output is controlled by the #define
":Bold p1='PMPRINTF_HERE_I_AM_MSG'.", you could #undef and then
#define your own after first including
":LinkToText p1='PMPRINTF_H' p2='PMPRINTF&per.H'.".

:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.

:Example.
    void DebugHereIAm(void);       //Its really a macro!
:eExample.


:BigTitle p1='EXAMPLE'.

.dm DebugHereIAmExample on
:Example.
   #include "PMPRINTF.H"
   #undef   PMPRINTF_HERE_I_AM_MSG
   #define  PMPRINTF_HERE_I_AM_MSG  " <Got to here OK>"

   DebugHereIAm();
:eExample.
.dm off
:DebugHereIAmExample.


.*===========================================================================
:Heading p1='Pmpf' p2='Pmpf'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.Pmpf

:BigTitle p1='DESCRIPTION - Pmpf'.

:p.This macro takes the same parameters as the 'C' libraries
'printf()' routine and sends it to the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'..

:p.The difference between using this macro and
:LinkToFunction p1='PmPrintf'. is that the  following will preceed
the message which is sent to the viewer&colon.

:OrdListCompact.
:li.The short name of the module (8.3 without path).
:li.The line number of this statement.
:eOrdListCompact.

:p.Note that I prefer to use the :LinkToFunction p1='PmpfF'. macro as
it also supplies the name of the current function.

:NoNewLineRequired.

:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.

:Example.
    void PmPf(char *Format, ...);    //Its really a macro!
:eExample.

:p.Note that the only realy painful part about using this macro (and
:LinkToFunction p1='PmpfF'.) is that you need to use double brackets
since 'C' macros can only take a fixed number of parameters.


:BigTitle p1='EXAMPLE'.


:Example.
   Pmpf(("Just opened the file \"%s\"", FileName));
:eExample.

.dm NeedDoubleBrackets on
:p.:Bold p1='Notice the double brackets at both ends, you must supply these.'.
.dm off
:NeedDoubleBrackets.



.*===========================================================================
:Heading p1='PmpfF' p2='PmpfF'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.PmpfF

:BigTitle p1='DESCRIPTION - PmpfF'.

:p.This macro takes the same parameters as the 'C' libraries
'printf()' routine and sends it to the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'..

:p.The difference between using this macro and
:LinkToFunction p1='PmPrintf'. is that the  following will preceed
the message which is sent to the viewer&colon.

:OrdListCompact.
:li.The short name of the module (8.3 without path).
:li.The line number of this statement.
:li.The name of the current function.
:eOrdListCompact.


:NoNewLineRequired.

:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.

:Example.
    void PmpfF(char *Format, ...);    //Its really a macro!
:eExample.

:p.Note that the only realy painful part about using this macro (and
:LinkToFunction p1='Pmpf'.) is that you need to use double brackets
since 'C' macros can only take a fixed number of parameters.


:BigTitle p1='EXAMPLE'.


:Example.
   PmpfF(("Just opened the file \"%s\"", FileName));
:eExample.

:NeedDoubleBrackets.



.*===========================================================================
:Heading p1='PmPrintf' p2='PmPrintf'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.PmPrintf

:BigTitle p1='DESCRIPTION - PmPrintf'.

:p.This function takes the same parameters as the 'C' libraries
'printf()' routine and sends it to the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'..

.dm NoNewLineRequired on
:p.Note that like all PMPRINTF operations a terminating new line is
not required and will if supplied generate a blank line.  If you wish
you may however send multiple lines - each terminated with a newline
('\n').
.dm off
:NoNewLineRequired.

:p.Useful as this function is, I normally use one of the following in
its place&colon.

:UnNumberedListCompact.
:li.:LinkToFunction p1='Pmpf'.
:li.:LinkToFunction p1='PmpfF'.
:eUnNumberedListCompact.

:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.


:Example.
    ULONG _System PmPrintf(char *Format, ...);
:eExample.

:Rc0IfOk.


:BigTitle p1='EXAMPLE'.


:Example.
   PmPrintf("Just opened the file \"%s\"", FileName);
:eExample.



.*===========================================================================
:Heading p1='PmPrintfString' p2='PmPrintfString'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.PmPrintfString

:BigTitle p1='DESCRIPTION - PmPrintfString'.

:p.This function takes a string and outputs it to the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'..

:NoNewLineRequired.
:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.


:Example.
    ULONG _System PmPrintfString(char *String);
:eExample.

:Rc0IfOk.

:BigTitle p1='EXAMPLE'.


:Example.
   PmPrintfString("I'm about to format your hard disk...");
:eExample.



.*===========================================================================
:Heading p1='PmPrintfVa' p2='PmPrintfVa'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC.PmPrintfVa

:BigTitle p1='DESCRIPTION - PmPrintfVa'.

:p.This function performs exactly the same functions as
:LinkToFunction p1='PmPrintf'. except that the variable parameters that are
passed to it are passed in a different format.

:p.This function would only be required if you have your own function
which takes a variable number of parameters and you wish to pass
these to the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'. (without you having to
handle the formatting yourself).

:NoNewLineRequired.
:CPmprintfTestCode.

:BigTitle p1='SYNTAX'.


:Example.
    ULONG _System PmPrintfVa(char *Format, va_list args);
:eExample.

:Rc0IfOk.

:BigTitle p1='EXAMPLE'.


:Example.
   static MyFunction(char * Format, ...)
   {
        va_list  args;
        ...
        ...
        va_start(args, Format);
        PmPrintfVa(Format, args);
        va_end(args);
        ...
        ...
   }
:eExample.




.*===========================================================================
:Heading p1='_DebugHereIAm' p2='_DebugHereIAm'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC._DebugHereIAm

:BigTitle p1='DESCRIPTION - _DebugHereIAm'.

:p.This macros takes exactly the same parameters as
:LinkToFunction p1='DebugHereIAm'. and does exactly the same job, the
only difference is that no code is generated unless
":Bold p1='_PMPRINTF_'." is #define'd before
":LinkToText p1='PMPRINTF_H' p2='PMPRINTF&per.H'." is included.

:BigTitle p1='EXAMPLE'.


:Example.
   #define  _PMPRINTF_
   #include "PMPRINTF.H"

   _DebugHereIAm();
:eExample.



.*===========================================================================
:Heading p1='_Pmpf' p2='_Pmpf'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC._Pmpf

:BigTitle p1='DESCRIPTION - _Pmpf'.

:p.This macros takes exactly the same parameters as
:LinkToFunction p1='Pmpf'. and does exactly the same job, the
only difference is that no code is generated unless
":Bold p1='_PMPRINTF_'." is #define'd before
":LinkToText p1='PMPRINTF_H' p2='PMPRINTF&per.H'." is included.

:BigTitle p1='EXAMPLE'.


:Example.
   #define  _PMPRINTF_
   #include "PMPRINTF.H"

   _Pmpf(("Just opened the file \"%s\"", FileName));
:eExample.



.*===========================================================================
:Heading p1='_PmpfF' p2='_PmpfF'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceC._PmpfF

:BigTitle p1='DESCRIPTION - _PmpfF'.

:p.This macros takes exactly the same parameters as
:LinkToFunction p1='Pmpf'. and does exactly the same job, the
only difference is that no code is generated unless
":Bold p1='_PMPRINTF_'." is #define'd before
":LinkToText p1='PMPRINTF_H' p2='PMPRINTF&per.H'." is included.

:BigTitle p1='EXAMPLE'.


:Example.
   #define  _PMPRINTF_
   #include "PMPRINTF.H"

   _PmpfF(("Just opened the file \"%s\"", FileName));
:eExample.


.*===========================================================================
:HeadingLevelUp.
:Heading p1='SourcePMPRINTF' p2='Source'.
.*===========================================================================

.*--- Define some automatic links ('C' interface) ---------------------------
$DefineTextChange "PMPRINTF&per.H"                        ":LinkToText p1='PMPRINTF_H' p2='PMPRINTF&per.H'."
$DefineTextChange "_PMPRINTF_"                            ":LinkToText p1='PMPRINTF_H' p2='_PMPRINTF_'."
$DefineTextChange "PMPRINTF_HERE_I_AM_MSG"                ":LinkToText p1='PMPRINTF_H' p2='PMPRINTF_HERE_I_AM_MSG'."
$DefineTextChange "_Pmpf("                                ":LinkTo p1='_Pmpf'.("
$DefineTextChange "_PmpfF("                               ":LinkTo p1='_PmpfF'.("
$DefineTextChange "_DebugHereIAm("                        ":LinkTo p1='_DebugHereIAm'.("
$DefineTextChange " PmPrintfQueueNameThisProcess"         " :LinkTo p1='PmPrintfQueueNameThisProcess'."
$DefineTextChange " PmPrintfDisplayInterfaceVersionInfo"  " :LinkTo p1='PmPrintfDisplayInterfaceVersionInfo'."
$DefineTextChange " PmPrintfModeSet"                      " :LinkTo p1='PmPrintfModeSet'."
$DefineTextChange " PmPrintfVa"                           " :LinkTo p1='PmPrintfVa'."
$DefineTextChange " PmPrintf("                            " :LinkTo p1='PmPrintf'.("
$DefineTextChange " PmPrintf "                            " :LinkTo p1='PmPrintf'. "
$DefineTextChange " PmPrintfString"                       " :LinkTo p1='PmPrintfString'."
$DefineTextChange " Pmpf("                                " :LinkTo p1='Pmpf'.("
$DefineTextChange " PmpfF("                               " :LinkTo p1='PmpfF'.("
$DefineTextChange " DebugHereIAm("                        " :LinkTo p1='DebugHereIAm'.("

.dm SourceMessage on
:p.I have supplied the source for the interface in case you have an
urgent need to modify it or you just wish to see how it works.  I
like to see code supplied as they can be good examples if you wish to
do something similar.

:p.If you have problems I would like to be told about these problems
so I can fix these for everyone (including myself!), if you find
any please contact
:LinkToText p1='DennisBareis' p2='Dennis Bareis'., thank you.

:p.Also note that you don't need to worry about the code and examples
shown in this document being out of date as the document is
automatically made as part of the make process which will include the
latest source at that time.
.dm off
:SourceMessage.



.*===========================================================================
:HeadingLevelDown.
:Heading p1='PMPRINTF_H' p2='PMPRINTF&per.H'.
.*===========================================================================


:BigTitle p1='PMPRINTF&per.H'.

:p.This header file should be included prior to any use of PMPRINTF
functions &amp. macros.

:p.The following macros will only produce output if you have
created the #define
":Bold p1='_PMPRINTF_'." prior to including this header file&colon.


:UnNumberedListCompact.
:PmprintfCategory3.
:eUnNumberedListCompact.

:p.Another option you have is to control the output generated by
:LinkToFunction p1='DebugHereIAm'. &amp. :LinkToFunction p1='_DebugHereIAm'.,
to do this you would first include this header and then #undef &amp.
#define your new string, for example&colon.

:DebugHereIAmExample.
:p.


:BigTitle p1='The Header file "PMPRINTF&per.H"'.

:Example.
.im PMPRINTF.H
:eExample.



.*===========================================================================
:Heading p1='PMPRINTF_C' p2='PMPRINTF&per.C'.
.*===========================================================================


:BigTitle p1='PMPRINTF&per.C'.

:Example.
.im PMPRINTF.C
:eExample.



.*===========================================================================
:Heading p1='PMPRINTF_DEF' p2='PMPRINTF&per.DEF'.
.*===========================================================================


:BigTitle p1='PMPRINTF&per.DEF'.

:Example.
.im PMPRINTF.DEF
:eExample.



.*===========================================================================
:HeadingLevelUp.
:Heading p1='CExample' p2='Example of &apos.C&apos. code displaying messages'.
.*===========================================================================
:i1 id=CExample.Example of 'C' code Interface


:BigTitle p1='Example of &apos.C&apos. code using PMPRINTF Interface'.


:Example.
.im TESTPF.C
:eExample.






.*===========================================================================
:HeadingLevelUp.
:Heading p1='PMPRINTFRexxInterface' p2='PMPRINTF Rexx Interface'.
.*===========================================================================
:i1 id=PmPrintfInterfaceRexx.PMPRINTF REXX Interface

:p.The following functions are available for rexx programs to
use&colon.

.dm RexxFunctionList on
:UnNumberedListCompact.
:li.:LinkToFunction p1='RexxPmpf'.
:li.:LinkToFunction p1='RexxPmPrintfModeSet'.
:li.:LinkToFunction p1='RexxPmPrintfQueueNameThisProcess'.
:eUnNumberedListCompact.
.dm off
:RexxFunctionList.


:p.To use any function in this interface you must first define it to
rexx in the standard way.  For example to make the function
:LinkToFunction p1='RexxPmpf'. available for use you would use the
rexx statement&colon.

:Example.
   call RxFuncAdd  'RexxPmpf', 'PmPrintf', 'RexxPmpf';
:eExample.

:p.At runtime the DLL "PMPRINTF.DLL" must also be available.


.dm RexxPmprintfTestCode on
:p.You may wish to see the
:LinkToText p1='RexxExample' p2='complete REXX program'.
which I use to test the
interface as it uses many different functions &amp. macros.
.dm off
:RexxPmprintfTestCode.



.*===========================================================================
:HeadingLevelDown.
:Heading p1='FunctionsRexxPMPRINTF' p2='Functions &amp. Macros'.
.*===========================================================================

:p.The following functions are available for rexx programs to
use&colon.

:RexxFunctionList.
:RexxPmprintfTestCode.

:HeadingLevelDown.


.*===========================================================================
:Heading p1='RexxPmpf' p2='RexxPmpf'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceRexx.RexxPmpf

:BigTitle p1='DESCRIPTION - RexxPmpf'.

:p.This function performs a similar function to
:LinkToFunction p1='Pmpf'. (although it does not use it) in that the output
will contain the following header fields&colon.


:OrdList.
:li.The short name of the rexx code module (8.3 without path).

:li.The line number of the last call to an internal procedure.  This
is due to a rexx bug or feature.  The line number is not the line of
the caller.
.br
.br
Note that you can get the line number of the caller if you are
prepared to create your own function as demonstrated below&colon.


:Example.
    /*--- Output some debug statements ------------------------*/
    call Debug('Opened file "' || FileName || '".');
    call Debug('Thats All Folks!');
    exit(0);


    /********/
    Debug:
    /********/
       return( RexxPmpf(arg(1)) );
:eExample.


:eOrdList.


:p.Please remember that a terminating newline is not required, but if
you wish to send multiple lines with a single call you should use the
newline character to seperate each line.

:RexxPmprintfTestCode.

:BigTitle p1='EXAMPLE'.

:p.Note that in the following example the header you will see in the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'. will show the line
number to be 0.  This is for the reason specified above.  You need to
create a Debug() function as described above if you need to get the
line number of the caller.


:Example.
   /*--- Define function to rexx ---*/
   call RxFuncAdd 'RexxPmpf', 'PmPrintf', 'RexxPmpf';

   /*--- Output a string -----------*/
   call RexxPmpf 'Opened file "' || FileName || '".';
:eExample.



.*===========================================================================
:Heading p1='RexxPmPrintfModeSet' p2='RexxPmPrintfModeSet'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceRexx.RexxPmPrintfModeSet

:BigTitle p1='DESCRIPTION - RexxPmPrintfModeSet'.

:p.This function is a front end to
:LinkToFunction p1='PmPrintfModeSet'..  It is passed the new mode and
returns the previous mode as a return code.

:p.Note that by default the mode
for the rexx interface has been made more rexx appropriate, for
example no process information is contained in the header.

:RexxPmprintfTestCode.

:BigTitle p1='EXAMPLE'.

:Example.
   /*--- Define function to rexx ---*/
   call RxFuncAdd 'RexxPmPrintfModeSet', 'PmPrintf', 'RexxPmPrintfModeSet';

   /*--- Set the mode --------------*/
   call RexxPmPrintfModeSet 0;
:eExample.



.*===========================================================================
:Heading p1='RexxPmPrintfQueueNameThisProcess' p2='RexxPmPrintfQueueNameThisProcess'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceRexx.RexxPmPrintfQueueNameThisProcess

:BigTitle p1='DESCRIPTION - RexxPmPrintfQueueNameThisProcess'.

:p.This function is a front end to
:LinkToFunction p1='PmPrintfQueueNameThisProcess'..  It is passed the
name of a queue that should be used.  There is no return code, if you
pass an invalid queue name then the rexx procedure will abort!

:RexxPmprintfTestCode.

:BigTitle p1='EXAMPLE'.

:Example.
   /*--- Define function to rexx ---*/
   call RxFuncAdd 'RexxPmPrintfQueueNameThisProcess', 'PmPrintf', 'RexxPmPrintfQueueNameThisProcess';

   /*--- Set the mode --------------*/
   call RexxPmPrintfModeSet 0;
:eExample.





.*===========================================================================
:HeadingLevelUp.
:Heading p1='RexxSource' p2='Source'.
.*===========================================================================

.*--- Define some automatic links (Rexx interface) --------------------------
$DefineTextChange "RexxPmpf"                         ":LinkTo p1='RexxPmpf'."
$DefineTextChange "RexxPmPrintfModeSet"              ":LinkTo p1='RexxPmPrintfModeSet'."
$DefineTextChange "RexxPmPrintfQueueNameThisProcess" ":LinkTo p1='RexxPmPrintfQueueNameThisProcess'."

:SourceMessage.



.*===========================================================================
:HeadingLevelDown.
:Heading p1='REXXPMPF_C' p2='REXXPMPF&per.C'.
.*===========================================================================

:BigTitle p1='REXXPMPF&per.C'.

:Example.
.im REXXPMPF.C
:eExample.


.*===========================================================================
:HeadingLevelUp.
:Heading p1='RexxExample' p2='Example of REXX code displaying messages'.
.*===========================================================================
:i1 id=RexxExample.Example of 'REXX' code Interface


:BigTitle p1='Example of REXX code using PMPRINTF Interface'.


:Example.
.im REXXTEST.CMD
:eExample.





.*===========================================================================
:HeadingLevelUp.
:HeadingLevelUp.
:Heading p1='WPSDEBUGInterface' p2='WPSDEBUG Interface (SOM &amp. WPS)'.
.*===========================================================================

:WpsDebugInterface.

.dm NeedNewLine on
:p.Note that unlike the PMPRINTF interface all WPSDEBUG operations
do require a terminating new line.  While this can get confusing I
can't think of a way to eliminate their requirement.
.dm off
:NeedNewLine.

.dm WpsDebugTestCode on
:p.You may wish to see the
:LinkToText p1='WpsExample' p2='complete WPS class'.
which I use to test the
interface as it uses many different functions &amp. macros.
.dm off
:WpsDebugTestCode.

.dm WpsCompRuntimeEnv on
:p.To use this interface you must include
":LinkToText p1='WPSDEBUG_H' p2='WPSDEBUG&per.H'." in your "C" code
and link to "WPSDEBUG.LIB" during the link step.  At runtime the
"WPSDEBUG.DLL" &amp. "PMPRINTF.DLL" must be available.
.dm off
:WpsCompRuntimeEnv.


.*===========================================================================
:HeadingLevelDown.
:Heading p1='FunctionsWPSDEBUG' p2='Functions &amp. Macros'.
.*===========================================================================
:i1 id=PmPrintfInterfaceWps.WPSDEBUG SOM &amp. WPS 'C' Interface

:WpsCompRuntimeEnv.

:p.The following functions &amp. macros are available for SOM/WPS
classes to use&colon.


:UnNumberedListCompact.
:li.:LinkToFunction p1='SOMMethodDebug'.
:li.:LinkToFunction p1='WpsDebug'.
:li.:LinkToFunction p1='WpsDebugF'.
:li.:LinkToFunction p1='WpsDebugHereIAm'.
:li.:LinkToFunction p1='WpsDebugHigh'.
:li.:LinkToFunction p1='WpsDebugInstall'.
:li.:LinkToFunction p1='WpsDebugMethodEnd'.
:li.:LinkToFunction p1='WpsDebugMethodStart'.
:li.:LinkToFunction p1='WpsDebugPmMsgBox'.
.dm WpsDebugConditionalMacros on
:li.:LinkToFunction p1='_WpsDebug'.
:li.:LinkToFunction p1='_WpsDebugF'.
:li.:LinkToFunction p1='_WpsDebugHereIAm'.
:li.:LinkToFunction p1='_WpsDebugHigh'.
:li.:LinkToFunction p1='_WpsDebugInstall'.
:li.:LinkToFunction p1='_WpsDebugMethodEnd'.
:li.:LinkToFunction p1='_WpsDebugMethodStart'.
.dm off
:WpsDebugConditionalMacros.
:eUnNumberedListCompact.

:NeedNewLine.
:WpsDebugTestCode.

:HeadingLevelDown.




.*===========================================================================
:Heading p1='SOMMethodDebug' p2='SOMMethodDebug'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.SOMMethodDebug

:BigTitle p1='DESCRIPTION - SOMMethodDebug'.

:p.This standard SOM macro is replaced when
":LinkToText p1='WPSDEBUG_H' p2='WPSDEBUG&per.H'." is included so as
to be formatted similar to all other output generated by my API.

:p.By default the :LinkToFunction p1='_WpsDebugF'. macro is used
to output all the standard header information as well as the class
name.  You should modify "WPSDEBUG_SOMMETHODDEBUG" after
the inclusion of the header file to change its behaviour, for example
to use :LinkToFunction p1='WpsDebugF'. (instead of
:LinkToFunction p1='_WpsDebugF'.) you could do the following&colon.


.dm SOMMethodDebugExample on
:ExampleFormatted.
    #include <WPSDEBUG.H>
    #undef   WPSDEBUG_SOMMETHODDEBUG
    #define  WPSDEBUG_SOMMETHODDEBUG(ClassName, MethodName)  \
             :LinkTo p1='WpsDebugF'.(("Class = \"%s\"\n", ClassName))
:eExampleFormatted.
.dm off
:SOMMethodDebugExample.
:WpsDebugTestCode.


.*===========================================================================
:Heading p1='WpsDebug' p2='WpsDebug'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.WpsDebug

:BigTitle p1='DESCRIPTION - WpsDebug'.

:p.This macro performs the same function as the :LinkToFunction p1='Pmpf'.
macro but for the SOM environment.

:p.I myself prefer to use the :LinkToFunction p1='WpsDebugF'. macro
in place of this one as it's header will include the name of the
current function.

:NeedNewLine.
:WpsDebugTestCode.


:BigTitle p1='SYNTAX'.

:Example.
    void WpsDebug(char * Format, ...);       //Its really a macro!
:eExample.


:BigTitle p1='EXAMPLE'.

:Example.
    WpsDebug(("About to call the parent method with Handle = %08X\n", Handle));
:eExample.
:NeedDoubleBrackets.


.*===========================================================================
:Heading p1='WpsDebugF' p2='WpsDebugF'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.WpsDebugF

:BigTitle p1='DESCRIPTION - WpsDebugF'.

:p.This macro performs the same function as the :LinkToFunction p1='PmpfF'.
macro but for the SOM environment.

:NeedNewLine.
:WpsDebugTestCode.


:BigTitle p1='SYNTAX'.

:Example.
    void WpsDebugF(char * Format, ...);       //Its really a macro!
:eExample.


:BigTitle p1='EXAMPLE'.

:Example.
    WpsDebugF(("About to call the parent method with Handle = %08X\n", Handle));
:eExample.
:NeedDoubleBrackets.



.*===========================================================================
:Heading p1='WpsDebugHereIAm' p2='WpsDebugHereIAm'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.WpsDebugHereIAm

:BigTitle p1='DESCRIPTION - WpsDebugHereIAm'.

:p.This macro takes no parameters and uses the
:LinkToFunction p1='WpsDebugF'. macro to display a fixed message.  This
of course means that very detailed information about where you are
will be generated by this very simple macro invokation.

:p.This macro is useful in cases where you are not sure if you are
reaching code you expect to and you don't want or need the hassle of
coding "I'm now at line 10 etc"...

:p.The value of the text which is output is controlled by the
#define ":Bold p1='WPSDEBUG_HERE_I_AM_MSG'.", you could #undef and then
#define your own after first including
":LinkToText p1='WPSDEBUG_H' p2='WPSDEBUG&per.H'.".

:WpsDebugTestCode.

:BigTitle p1='SYNTAX'.

:Example.
    void WpsDebugHereIAm(void);       //Its really a macro!
:eExample.


:BigTitle p1='EXAMPLE'.

.dm WpsDebugHereIAmExample on
:Example.
   #include "WPSDEBUG.H"
   #undef   WPSDEBUG_HERE_I_AM_MSG
   #define  WPSDEBUG_HERE_I_AM_MSG  " <Got to here OK>"

   WpsDebugHereIAm();
:eExample.
.dm off
:WpsDebugHereIAmExample.



.*===========================================================================
:Heading p1='WpsDebugHigh' p2='WpsDebugHigh'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.WpsDebugHigh

:BigTitle p1='DESCRIPTION - WpsDebugHigh'.

:p.This macro takes no parameters and uses the
:LinkToFunction p1='WpsDebugInstall'. macro as follows&colon.


:Example.
    #define  WpsDebugHigh()                                \
             WpsDebugInstall(WPSDEBUG_TLEVEL_CORE_AND_USER, PMPRINTF_ALL_HEADER_FIELDS_EXCEPT_TIME)
:eExample.

:p.As you can see all header fields except the time are turned on, if
the time is wanted the
:LinkToText p1='PMPRINTF_EXE' p2='PM viewer'. can display it.

.dm BestPlaceForStartingDebugging on
:p.The best place for this macro is at the start of the class or
object "InitData" methods, this ensures that following debug
statements will generate output!
.dm off
:BestPlaceForStartingDebugging.

:WpsDebugTestCode.


:BigTitle p1='SYNTAX'.

:Example.
    void WpsDebugHigh(void);       //Its really a macro!
:eExample.


:BigTitle p1='EXAMPLE'.


:Example.
   WpsDebugHigh();
:eExample.



.*===========================================================================
:Heading p1='WpsDebugInstall' p2='WpsDebugInstall'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.WpsDebugInstall

:BigTitle p1='DESCRIPTION - WpsDebugInstall'.

:p.This macro takes two parameters to determine the trace level and
thw WPSDEBUG trace mode.  I usually use the macro
:LinkToFunction p1='WpsDebugHigh'. instead as it is similier to use
and does everything I want.

:BestPlaceForStartingDebugging.
:WpsDebugTestCode.


:BigTitle p1='SYNTAX'.

:ExampleFormatted.
    void WpsDebugInstall(int TraceLevel, :LinkToText p1='PmPrintfModeSet' p2='PMPRINTF_MODE'. :LinkToText p1='PmPrintfModeSet' p2='PmprintfMode'.); //Its really a macro!
:eExampleFormatted.

:p.The :Magenta p1='TraceLevel'. field should be passed oone of&colon.


:ExampleFormatted.
:UnNumberedListCompact.
:li.#define   WPSDEBUG_TLEVEL_NONE          0
:li.#define   WPSDEBUG_TLEVEL_USER          1
:li.#define   WPSDEBUG_TLEVEL_CORE_AND_USER 2
:eUnNumberedListCompact.
:eExampleFormatted.

:p.The :Magenta p1='PmprintfMode'. parameter is as documented for the
:LinkToFunction p1='PmPrintfModeSet'. function.



:BigTitle p1='EXAMPLE'.


:Example.
   WpsDebugInstall(WPSDEBUG_TLEVEL_CORE_AND_USER, PMPRINTF_ALL_HEADER_FIELDS_EXCEPT_TIME);
:eExample.



.*===========================================================================
:Heading p1='WpsDebugMethodEnd' p2='WpsDebugMethodEnd'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.WpsDebugMethodEnd

:BigTitle p1='DESCRIPTION - WpsDebugMethodEnd'.

:p.This macro takes no parameters and is a variation of the simplier
:LinkToFunction p1='WpsDebugHereIAm'. macro.  This macro is intended
to be placed at return points from your methods, the debug line
indicates your method is being left.  This macro could be used in
conjunction with :LinkToFunction p1='WpsDebugMethodStart'. or
:LinkToFunction p1='SOMMethodDebug'. to indicate when your methods
start &amp. end processing.

.*This macro is intended
.* to be used at the start of a method in place of SOMMethodDebug

:WpsDebugTestCode.


:BigTitle p1='SYNTAX'.

:ExampleFormatted.
    void WpsDebugMethodEnd(void)     //Its really a macro!
:eExampleFormatted.


:BigTitle p1='EXAMPLE'.

:Example.
   WpsDebugMethodEnd();
:eExample.



.*===========================================================================
:Heading p1='WpsDebugMethodStart' p2='WpsDebugMethodStart'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.WpsDebugMethodStart

:BigTitle p1='DESCRIPTION - WpsDebugMethodStart'.

:p.This macro takes no parameters and is a variation of the simplier
:LinkToFunction p1='WpsDebugHereIAm'. macro.  This macro is intended
to be used at the start of a method in place of the
:LinkToFunction p1='SOMMethodDebug'. macro (if thats what you wish to
do), either of these two macros can be in
conjunction with :LinkToFunction p1='WpsDebugMethodEnd'. to indicate
when your methods start &amp. end processing.


:WpsDebugTestCode.


:BigTitle p1='SYNTAX'.

:ExampleFormatted.
    void WpsDebugMethodStart(void)    //Its really a macro!
:eExampleFormatted.


:BigTitle p1='EXAMPLE'.

:Example.
   WpsDebugMethodStart();
:eExample.



.*===========================================================================
:Heading p1='WpsDebugPmMsgBox' p2='WpsDebugPmMsgBox'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps.WpsDebugPmMsgBox

:BigTitle p1='DESCRIPTION - WpsDebugPmMsgBox'.

:p.This function provides a very simple way to display a PM message
box using a syntax very much like that used for printf().

:WpsDebugTestCode.


:BigTitle p1='SYNTAX'.

:ExampleFormatted.
void _Optlink WpsDebugPmMsgBox( char  * Title,
                                char  * Format,
                                ...
                              );
:eExampleFormatted.


:BigTitle p1='EXAMPLE'.

:Example.
   WpsDebugPmMsgBox("CAN'T OPEN FILE", "Could not open the file \"%s\"", FileName);
:eExample.



.*===========================================================================
:Heading p1='_WpsDebug' p2='_WpsDebug'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps._WpsDebug

:BigTitle p1='DESCRIPTION - _WpsDebug'.

:p.This macro performs exactly the same function as
:LinkToFunction p1='WpsDebug'. except that it will only generate the
debug code at compile time if
":LinkToText p1='WPSDEBUG_H' p2='_WPSDEBUG_'." has been defined.

:WpsDebugTestCode.
.*===========================================================================
:Heading p1='_WpsDebugF' p2='_WpsDebugF'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps._WpsDebugF

:BigTitle p1='DESCRIPTION - _WpsDebugF'.

:p.This macro performs exactly the same function as
:LinkToFunction p1='WpsDebug'. except that it will only generate the
debug code at compile time if
":LinkToText p1='WPSDEBUG_H' p2='_WPSDEBUG_'." has been defined.

:WpsDebugTestCode.



.*===========================================================================
:Heading p1='_WpsDebugHereIAm' p2='_WpsDebugHereIAm'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps._WpsDebugHereIAm

:BigTitle p1='DESCRIPTION - _WpsDebugHereIAm'.

:p.This macro performs exactly the same function as
:LinkToFunction p1='WpsDebug'. except that it will only generate the
debug code at compile time if
":LinkToText p1='WPSDEBUG_H' p2='_WPSDEBUG_'." has been defined.

:WpsDebugTestCode.



.*===========================================================================
:Heading p1='_WpsDebugHigh' p2='_WpsDebugHigh'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps._WpsDebugHigh

:BigTitle p1='DESCRIPTION - _WpsDebugHigh'.

:p.This macro performs exactly the same function as
:LinkToFunction p1='WpsDebug'. except that it will only generate the
debug code at compile time if
":LinkToText p1='WPSDEBUG_H' p2='_WPSDEBUG_'." has been defined.

:WpsDebugTestCode.




.*===========================================================================
:Heading p1='_WpsDebugInstall' p2='_WpsDebugInstall'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps._WpsDebugInstall

:BigTitle p1='DESCRIPTION - _WpsDebugInstall'.

:p.This macro performs exactly the same function as
:LinkToFunction p1='WpsDebug'. except that it will only generate the
debug code at compile time if
":LinkToText p1='WPSDEBUG_H' p2='_WPSDEBUG_'." has been defined.

:WpsDebugTestCode.



.*===========================================================================
:Heading p1='_WpsDebugMethodEnd' p2='_WpsDebugMethodEnd'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps._WpsDebugMethodEnd

:BigTitle p1='DESCRIPTION - _WpsDebugMethodEnd'.

:p.This macro performs exactly the same function as
:LinkToFunction p1='WpsDebug'. except that it will only generate the
debug code at compile time if
":LinkToText p1='WPSDEBUG_H' p2='_WPSDEBUG_'." has been defined.

:WpsDebugTestCode.



.*===========================================================================
:Heading p1='_WpsDebugMethodStart' p2='_WpsDebugMethodStart'.
.*===========================================================================
:i2 refid=PmPrintfInterfaceWps._WpsDebugMethodStart

:BigTitle p1='DESCRIPTION - _WpsDebugMethodStart'.

:p.This macro performs exactly the same function as
:LinkToFunction p1='WpsDebug'. except that it will only generate the
debug code at compile time if
":LinkToText p1='WPSDEBUG_H' p2='_WPSDEBUG_'." has been defined.

:WpsDebugTestCode.






.*===========================================================================
:HeadingLevelUp.
:Heading p1='SourceWPSDEBUG' p2='Source'.
.*===========================================================================
:SourceMessage.

.*--- Define some automatic links ('C' interface) ---------------------------
$DefineTextChange "WPSDEBUG&per.H"                 ":LinkToText p1='WPSDEBUG_H' p2='WPSDEBUG&per.H'."
$DefineTextChange "_WPSDEBUG_"                     ":LinkToText p1='WPSDEBUG_H' p2='_WPSDEBUG_'."
$DefineTextChange "WPSDEBUG_HERE_I_AM_MSG"         ":LinkToText p1='WPSDEBUG_H' p2='WPSDEBUG_HERE_I_AM_MSG'."
$DefineTextChange "WpsTestMethodDebug("            ":LinkToText p1='SOMMethodDebug' p2='WpsTestMethodDebug'.("
$DefineTextChange "SOMMethodDebug("                ":LinkTo p1='SOMMethodDebug'.("
$DefineTextChange " WpsDebug("                     " :LinkTo p1='WpsDebug'.("
$DefineTextChange " WpsDebugF("                    " :LinkTo p1='WpsDebugF'.("
$DefineTextChange " WpsDebugHereIAm("              " :LinkTo p1='WpsDebugHereIAm'.("
$DefineTextChange " WpsDebugHigh("                 " :LinkTo p1='WpsDebugHigh'.("
$DefineTextChange " WpsDebugInstall("              " :LinkTo p1='WpsDebugInstall'.("
$DefineTextChange " WpsDebugMethodEnd("            " :LinkTo p1='WpsDebugMethodEnd'.("
$DefineTextChange " WpsDebugMethodStart("          " :LinkTo p1='WpsDebugMethodStart'.("
$DefineTextChange " WpsDebugPmMsgBox("             " :LinkTo p1='WpsDebugPmMsgBox'.("
$DefineTextChange " _WpsDebug("                    " :LinkTo p1='_WpsDebug'.("
$DefineTextChange " _WpsDebugF("                   " :LinkTo p1='_WpsDebugF'.("
$DefineTextChange " _WpsDebugHereIAm("             " :LinkTo p1='_WpsDebugHereIAm'.("
$DefineTextChange " _WpsDebugHigh("                " :LinkTo p1='_WpsDebugHigh'.("
$DefineTextChange " _WpsDebugInstall("             " :LinkTo p1='_WpsDebugInstall'.("
$DefineTextChange " _WpsDebugMethodEnd("           " :LinkTo p1='_WpsDebugMethodEnd'.("
$DefineTextChange " _WpsDebugMethodStart("         " :LinkTo p1='_WpsDebugMethodStart'.("


.*===========================================================================
:HeadingLevelDown.
:Heading p1='WPSDEBUG_H' p2='WPSDEBUG&per.H'.
.*===========================================================================


:BigTitle p1='WPSDEBUG&per.H'.

:p.This header file should be included prior to any use of WPSDEBUG
functions &amp. macros.

:p.The following macros will only produce output if you have
created the #define
":Bold p1='_WPSDEBUG_'." prior to including this header file&colon.


:UnNumberedListCompact.
:WpsDebugConditionalMacros.
:eUnNumberedListCompact.

:p.Another option you have is to control the output generated by
:LinkToFunction p1='WpsDebugHereIAm'. &amp.
:LinkToFunction p1='_WpsDebugHereIAm'., to do this you would first
include this header and then #undef &amp.
#define your new string, for example&colon.

:WpsDebugHereIAmExample.

:p.A third option is to control the output from the
:LinkToFunction p1='SOMMethodDebug'. macro. An example follows&colon.
:SOMMethodDebugExample.

:p.


:BigTitle p1='The Header file "WPSDEBUG&per.H"'.

:Example.
.im WPSDEBUG.H
:eExample.


.*===========================================================================
:Heading p1='WPSDEBUG_C' p2='WPSDEBUG&per.C'.
.*===========================================================================


:BigTitle p1='WPSDEBUG&per.C'.

:Example.
.im WPSDEBUG.C
:eExample.


.*===========================================================================
:Heading p1='WPSDEBUG_DEF' p2='WPSDEBUG&per.DEF'.
.*===========================================================================


:BigTitle p1='WPSDEBUG&per.DEF'.

:Example.
.im WPSDEBUG.DEF
:eExample.


.*===========================================================================
:HeadingUp p1='WpsExample' p2='Example of WPS class'.
.*===========================================================================

:p.This example is made up of two components&colon.


:UnNumberedListCompact.
:li.":LinkToText p1='WPSTEST_C'   p2='WPSTEST&per.C'."
:li.":LinkToText p1='WPSTEST_CSC' p2='WPSTEST&per.CSC'."
:eUnNumberedListCompact.

:p.I have included the "CSC" to help anyone out there begin a simple
class.  If you are starting from scratch take everything documented
with a grain of salt, here are some examples&colon.


:OrdList.
:li.Depending one what you are doing your class "InitData" method can
be called multiple times (not just the once documented).

:li.There can be multiple instances of class data!!!!!!!!!  Use
global variables is you really only want one instance!
:eOrdList.

:p.Note that ":Bold p1='&per.CSC'." files are a little out of date, however
as I'm still using CSET v2.01 at home this will have to do, I will
not include an ":Bold p1='&per.IDL'." until I can test it to ensure
it works.

:HeadingLevelDown.



.*===========================================================================
:Heading p1='WPSTEST_C' p2='WPSTEST&per.C'.
.*===========================================================================


:BigTitle p1='WPSTEST&per.C'.

:Example.
.im WPSTEST.C
:eExample.



.*===========================================================================
:Heading p1='WPSTEST_CSC' p2='WPSTEST&per.CSC'.
.*===========================================================================


:BigTitle p1='WPSTEST&per.CSC'.

:Example.
.im WPSTEST.CSC
:eExample.




.*===========================================================================
:HeadingLevelUp.
:HeadingLevelUp.
:Heading p1='Changes' p2='Changes'.
.*===========================================================================


.*===========================================================================
:HeadingLevelDown.
:Heading p1='ChangesToPMPFLOGEXE' p2='Changes to PMPFLOG&per.EXE'.
.*===========================================================================

:p.The following describes past &amp. future changes
to ":LinkToText p1='PMPFLOG_EXE' p2='PMPFLOG&per.EXE'."...


:OrdList.
.*############################################################################
:li.:Magenta p1='Proposed'.
.*############################################################################

:UnNumberedListCompact.
:li.Look for EOF char on log when appending as is done for
:LinkToText p1='PMPRINTF_EXE' p2='PMPRINTF&per.EXE'..
:eUnNumberedListCompact.



.*############################################################################
:li.:Magenta p1='Version 96.231'.
.*############################################################################

:UnNumberedListCompact.
:li.First version of this program.
:eUnNumberedListCompact.

:eOrdList.





.*===========================================================================
:Heading p1='ChangesToPMPRINTFEXE' p2='Changes to PMPRINTF&per.EXE'.
.*===========================================================================

:p.The following describes past &amp. future changes
to ":LinkToText p1='PMPRINTF_EXE' p2='PMPRINTF&per.EXE'."...


:OrdList.
.*############################################################################
:li.:Magenta p1='Proposed'. (original written from Dennis. I, Andreas Buchinger, do not plan any further changes)
.*############################################################################

:UnNumberedListCompact.
:li.Fix color on listbox (does not get saved).

:li.Tab/Shift+Tab to quickly move left + Right in window

:li.Delete key to remove highlighted lines after request is
confirmed.

:li.Select the initial text in the question dialog.


:li.:LinkToText p1='DennisBareis' p2='Any suggestions'.?

:eUnNumberedListCompact.



.*############################################################################
:li.:Magenta p1='Version 96.254 (internal, not distributed yet'.
.*############################################################################

:UnNumberedListCompact.
:li.20170408 Changed stack to 0x80000 (was alreade set but not in distributed files, rebuild, requested by Yuri)
:li.

:eUnNumberedListCompact.




.*############################################################################
:li.:Magenta p1='Version 96.253'.
.*############################################################################

:UnNumberedListCompact.
:li.Added floating point support.
:li.Chanded default time format to 24h style (You can override this of course in the 'Time's Format' dialog).

:eUnNumberedListCompact.





.*############################################################################
:li.:Magenta p1='Version 96.252'.
.*############################################################################

:UnNumberedListCompact.
:li.Default listbox font is now Helv 8.

:eUnNumberedListCompact.





.*############################################################################
:li.:Magenta p1='Version 96.231'.
.*############################################################################

:UnNumberedListCompact.
:li.When logging data is flushed to file system if no messages
waiting in the queue.

:li.Lots of code reorganised to create as much common code as
possible between this program and
":LinkToText p1='PMPFLOG_EXE' p2='PMPFLOG&per.EXE'.".

:eUnNumberedListCompact.


.*############################################################################
:li.:Magenta p1='Version 96.163'.
.*############################################################################

:UnNumberedListCompact.
:li.Save/restore position &amp. presentation parameters.

:li.Got rid of awful "beep" noises if you have MMOS2 etc.

:li.Real help, still working on it, you're looking at it!

:li.The <ESC> key no longer erases the output, use <ALT><E>.

:li.No more option to save position.

:li.All hots keys changed to <Ctrl>+? from <Alt>+?, now both cases
work as well!

:li.Now have hot key to Halt/Restart  <ctrl><H>

:li.Removed self test code.

:li.Took out 16 bit conditional code.

:li.Increased the size of the stacks used (play safe).

:li.Maximum lines kept by default is now 5000, you can change.

:li.Menus reorganised (hopefully more logical).

:li.Now have a context menu.

:li.Now use standard file dialog to choose name of log file.

:li.Display the time on arrival on screen (in the format you choose).

:li.Press Enter an you will be prompted for a
:LinkToText p1='ActionAddComment' p2='comment'., if is inserted
following the highlighted line.  If none highlighted then comment
added to end.  The new comment is highlighted allowing easy creation
of multi-line messages.  Note that these are logged to end of log!

:li.Find (Next &amp. Previous).

:li.PMPRINTF.EXE is much faster to update window (approx 3 times
faster).

:li.Fixed bug where when PMPRINTF starts listbox does not have focus.

:li.Log file now opened in OPEN_SHARE_DENYWRITE mode.

:li.Million new options.

:li.
:eUnNumberedListCompact.


:eOrdList.







.*===========================================================================
:Heading p1='ChangesToProgInterface' p2='Changes to Programmers Interface'.
.*===========================================================================



:OrdList.
.*############################################################################
:li.:Magenta p1='Proposed'.
.*############################################################################

:UnNumberedListCompact.
:li.The disabling of PMPRINTF with the environment variable
 ":Bold p1='NOPMPRINTF'." could be improved so that you provide a
list of queues that should be
disabled so that you can allow some to continue to work.

:li.We probably now require PmPrinfDisable() &amp. PmPrinfEnable()
functions.

:li.:LinkToText p1='DennisBareis' p2='Any suggestions'.?

:eUnNumberedListCompact.



.*############################################################################
:li.:Magenta p1='Version 96.272'.
.*############################################################################

:UnNumberedListCompact.
:li.You can now disable the PMPRINTF API by setting the environment
variable ":Bold p1='NOPMPRINTF'." (to any value).  This has been
requested by someone and probably improves performance when not
debugging...
:eUnNumberedListCompact.



.*############################################################################
:li.:Magenta p1='Version 96.235'.
.*############################################################################

:UnNumberedListCompact.
:li.Now the default is not to beep on error and there is a bit to
enable beeping on error.
:eUnNumberedListCompact.


.*############################################################################
:li.:Magenta p1='Version 96.163'.
.*############################################################################

:UnNumberedListCompact.
:li.Created :LinkToText p1='PMPRINTFRexxInterface' p2='Rexx interface'., this
of course means that standard batch files could also be made to
log via a small rexx script. Put code in PMPRINTF.DLL
:li.Created :LinkToText p1='PMPRINTFCInterface' p2='PMPRINTF &apos.C&apos. Interface'..
:li.Created :LinkToText p1='WPSDEBUGInterface' p2='WPSDEBUG Interface (SOM &amp. WPS) Interface'.
:eUnNumberedListCompact.


:eOrdList.



.*===========================================================================
:HeadingLevelUp.
:Heading p1='DennisBareis' p2='The Author'.
.*===========================================================================

:p.My name is Dennis Bareis (in Australia), if you have any comments
or suggestions then you can email me on
:Bold p1='dbareis@ozemail.com.au'..

:p.Note that I currently read my email about once a week and that I
never have enough time!  If requests for changes arrive I will queue
these and do the lot in one hit.  I've recently had an idea for
something else that needs writing so here I go again...

:p.Again I only think its fair to point out that
:Bold p1='Mike Cowlishaw'., from the IBM UK Laboratories originally
developed the code for PMPRINTF.EXE, not much has happened
since 1993 so when I
managed to obtain the source for the PM program I could not resist
tinkering...

:p.20090307 Andreas Buchinger: As PMPrintf did not support output of floating point variables,
I asked Dennis about this problem. He do not work on pmprintf anymore and so he generously gave
me the sources. I compiled with IBMCPP3.65 and linked with the floating point library. If you have
problems with this version you can email me.

:p.20170829 AB: Increased stack size from 20kB to 512kB (requested by Yuri)

:p.20180216 AB: Added buildlevel info

:p.Andreas Buchinger, andi.os2.software@gmx.net
DO NOT MAKE THIS EMAIL ADDRESS PUBLIC.
DO NOT SEND ME ANY SORT OF ADVERTISING OR SPAM.
(Unwanted advertising and spam is prohibited by law in my home country. Doing so can be fined)


:euserdoc.



